<template>
  <div class="schedule-with-calendar">
    <schedule class="schedule-with-calendar__schedule"
              :scheduleRules="room.schedule"
              :roomId="room.id"
              :minMaxTimes="minMaxTimes"
              :minDuration="minDuration"
              :quantise="bookingQuantise"
              :bookings="bookings"
              :noOwnBookings="noOwnBookings"
              ref="schedule"
              :timezone="room.timezone"
              :getNoWorkingHours="getNoWorkingHours"
              :selectWithVisitors="selectWithVisitors"
    >

      <template v-slot:title v-if="hasTitle">
        <div class="schedule__top-row">
          <h4 class="schedule__title">Расписание</h4>

          <div class="schedule__arrow"
               v-if="isMobile"
               @click="mobileToTop">
            <icon-small-arrow />
          </div>
        </div>
      </template>
    </schedule>

    <client-only>
      <full-calendar class="schedule-with-calendar__calendar"
                     :bookings="bookings"
                     :chosenItems="calendarSchedule"
                     :minMaxTimes="minMaxTimes"
                     :changeStep="bookingQuantise"
                     :minDuration="minDuration"
                     :noOwnBookings="formatBookingsForCalendar(noOwnBookings)"
                     :roomId="room.id"
                     :timezone="room.timezone"
                     :schedule="room.schedule"
                     :getNoWorkingHours="getNoWorkingHours"
                     :selectWithVisitors="selectWithVisitors"
      />
    </client-only>
  </div>
</template>

<script>
  import { mapMutations } from 'vuex';

  import Schedule from '../components/Schedule';
  import IconSmallArrow from './icons/IconSmallArrow';

  import { getBookings } from '../service/deliroom-service';
  import getMinMaxTimes from '../assets/js/helpers/get-min-max-times';
  import { getFloatTime } from '../assets/js/helpers/formatTime';
  import { timeZoneOffsets } from '../assets/js/helpers/consts';

  export default {
    name: 'ScheduleWithCalendar',
    props: {
      room: {
        type: Object,
        required: true
      },

      hasTitle: {
        type: Boolean,
        default: true
      },

      mobileToTop: {
        type: Function,
        required: false
      }
    },
    components: {
      IconSmallArrow,
      Schedule,
    },
    data: () => ({
      bookings: [],
      minMaxTimes: {},
      noOwnBookings: [],
      bookingQuantise: '',
      minDuration: '',
    }),

    async beforeMount() {
      this.minMaxTimes = getMinMaxTimes(this.room);

      this.bookingQuantise = this.room.booking_quantise.match(/\d{2}:\d{2}:\d{2}/g)[0];
      this.minDuration = this.room.booking_min_duration.match(/\d{2}:\d{2}:\d{2}/g)[0];
    },

    async mounted() {
      const timer = setInterval(async () => {
        if (!this.$store.state.auth.tokenRefreshing) {
          clearInterval(timer);
          this.bookings = await getBookings(this.$route.params.id);

          const formattedBookings = [];

          this.bookings.forEach((booking) => {

            const startDate = new Date(booking.start.replace('Z', timeZoneOffsets[this.room.timezone].forCalendar));
            const endDate = new Date(booking.end.replace('Z', timeZoneOffsets[this.room.timezone].forCalendar));

            booking.start = startDate.toISOString();
            booking.end = endDate.toISOString();

            if (startDate.getFullYear() === endDate.getFullYear() && startDate.getMonth() === endDate.getMonth() && startDate.getDate() === endDate.getDate()) {
              const currentDate = Number(new Date(booking.start) - (timeZoneOffsets[this.room.timezone].float * 60 * 60 * 1000));

              formattedBookings.push({
                bookingId: booking.id,
                date: new Date(currentDate),
                price: booking.price,
                price_old: booking.price_old,
                timeFrom: {
                  label: booking.start.substr(11, 5),
                  value: getFloatTime(booking.start.substr(11, 5))
                },
                timeTo: {
                  label: getFloatTime(booking.end.substr(11, 5)) === 0 ? '24:00' : booking.end.substr(11, 5),
                  value: getFloatTime(booking.end.substr(11, 5)) === 0 ? 24 : getFloatTime(booking.end.substr(11, 5))
                },
                owner: booking.owner,
                ordered: booking.ordered,
                visitors: booking.visitors
              })

            } else {

              const daysCount = (endDate - startDate) / 1000 / 3600 / 24;

              for (let i = 0; i < daysCount; i++) {
                const currentDate = Number(new Date(booking.start)) + (1000 * 3600 * 24 * i);

                formattedBookings.push({
                  bookingId: booking.id,
                  date: new Date(currentDate),
                  price: booking.price,
                  price_old: booking.price_old,
                  timeFrom: {
                    label: booking.start.substr(11, 5),
                    value: getFloatTime(booking.start.substr(11, 5))
                  },
                  timeTo: {
                    label: getFloatTime(booking.end.substr(11, 5)) === 0 ? '24:00' : booking.end.substr(11, 5),
                    value: getFloatTime(booking.end.substr(11, 5)) === 0 ? 24 : getFloatTime(booking.end.substr(11, 5))
                  },
                  owner: booking.owner,
                  ordered: booking.ordered
                })
              }


            }
          });

          this.noOwnBookings = formattedBookings.filter((booking) => booking.owner === false);

          const ownBookings = formattedBookings.filter((booking) => booking.owner);
          this.fillStoreByOwnBookings({ roomId: this.room.id, bookings: ownBookings });

        }
      }, 100)
    },
    computed: {
      isMobile() {
        return this.$store.state.isMobile;
      },

      calendarSchedule() {
        const result = [];
        const currentBookings = this.$store.state.schedule.bookings.filter((booking) => booking.roomId === this.room.id)[0];

        if (!currentBookings) return result;

        currentBookings.bookingItems.forEach((scheduleItem) => {
          if (!scheduleItem) return;
          const currentISODate = scheduleItem.date.toLocaleDateString().replace(/(\d+).(\d+).(\d+)/, '$3-$2-$1');

          result.push({
            id: scheduleItem.bookingId,
            start: `${currentISODate}T${scheduleItem.timeFrom.label}`,
            end: `${currentISODate}T${scheduleItem.timeTo.label}`,
            owner: true,
            ordered: scheduleItem.ordered
          })
        });

        return result;
      },
    },
    methods: {
      ...mapMutations({
        fillStoreByOwnBookings: 'schedule/fillStoreByOwnBookings'
      }),

      addScheduleRow() {
        this.$refs.schedule.addRow();
      },

      getNoWorkingHours(date) {
        const dayIndex = date.getDay() || 7;
        const intervals = [];
        let tmpTime = '';

        let neededScheduleItems = this.room.schedule.filter((scheduleItem) => scheduleItem.rules.weekdays.includes(dayIndex));

        debugger;
        // Если нет объектов расписания с таким днем недели - значит это нерабочий день,
        // отправляем промежуток от минимального до максимального
        if (!neededScheduleItems.length) return [{
          from: getFloatTime(this.minMaxTimes.startTime),
          to: getFloatTime(this.minMaxTimes.endTime)
        }];

        neededScheduleItems.sort((a, b) =>
          getFloatTime(a.rules.from) > getFloatTime(b.rules.from) ? 1 :
            getFloatTime(a.rules.from) < getFloatTime(b.rules.from) ? -1 : 0);

        let timesToFilterRepeat = null;

        neededScheduleItems = neededScheduleItems.filter((scheduleItem) => {
          if (timesToFilterRepeat && timesToFilterRepeat.from === scheduleItem.rules.from
            && timesToFilterRepeat.to === scheduleItem.rules.to) return;

          timesToFilterRepeat = { from: scheduleItem.rules.from, to: scheduleItem.rules.to };

          return scheduleItem;
        });

        neededScheduleItems.forEach((scheduleItem) => {
          if (tmpTime && scheduleItem.rules.from !== tmpTime) {
            intervals.push({ from: getFloatTime(tmpTime), to: getFloatTime(scheduleItem.rules.from) })
          }

          tmpTime = scheduleItem.rules.to;
        });

        if (getFloatTime(neededScheduleItems[0].rules.from) !== getFloatTime(this.minMaxTimes.startTime)) {
          intervals.push({
            from: getFloatTime(this.minMaxTimes.startTime),
            to: getFloatTime(neededScheduleItems[0].rules.from)
          })
        }

        if ((getFloatTime(neededScheduleItems[neededScheduleItems.length - 1].rules.to) || 24) !== getFloatTime(this.minMaxTimes.endTime)) {
          intervals.push({
            from: getFloatTime(neededScheduleItems[neededScheduleItems.length - 1].rules.to),
            to: getFloatTime(this.minMaxTimes.endTime)
          })
        }

        return intervals;
      },

      formatBookingsForCalendar(bookings) {
        const result = [];

        bookings.forEach((booking) => {
          if (!booking) return;
          const currentISODate = booking.date.toLocaleDateString().replace(/(\d+).(\d+).(\d+)/, '$3-$2-$1');

          result.push({
            id: booking.bookingId,
            start: `${currentISODate}T${booking.timeFrom.label}`,
            end: `${currentISODate}T${booking.timeTo.label}`,
            owner: booking.owner,
          })
        });

        return result;
      },

      selectWithVisitors(timeFrom, timeTo, date, options = {}) {
        let visitors = []
        let minVisitors = null
        let maxVisitors = null
        const rowInfoWeekday = new Date(date).getDay()

        this.room.schedule.forEach(scheduleItem => {
          const weekdayCheck = scheduleItem.rules.weekdays.includes(rowInfoWeekday === 0 ? 7 : rowInfoWeekday)
          // если передом между началом и концом или если задом между началом и концом временного промежутка schedule
          if (
            ((timeFrom >= getFloatTime(scheduleItem.rules.from) && timeFrom < (getFloatTime(scheduleItem.rules.to) || 24)) ||
              (timeTo > getFloatTime(scheduleItem.rules.from) && timeTo <= (getFloatTime(scheduleItem.rules.to) || 24))) &&
            weekdayCheck
          ) {
            if (scheduleItem.rules.visitors !== null) {
              minVisitors = minVisitors ? Math.min(minVisitors, scheduleItem.rules.visitors.min) : scheduleItem.rules.visitors.min
              maxVisitors = maxVisitors ? Math.max(maxVisitors, scheduleItem.rules.visitors.max) : scheduleItem.rules.visitors.max
            }
          }
        })
        if (minVisitors && maxVisitors) {
          for (let i = minVisitors; i <= maxVisitors; i++) {
            visitors.push(i)
          }
        }

        if (options.hasOwnProperty('index')) {
          return visitors.length ? visitors[options.index] : null
        }

        return visitors.length ? visitors : null
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .schedule-with-calendar {
    margin: rem(70) 0;

    @media (max-width: $mobile-width) {
      margin: rem(44) 0;
    }

    &__calendar {
      margin-top: rem(60);

      @media (max-width: $mobile-width) {
        margin-top: rem(44);
      }
    }

  }
</style>
